/*All ADuC706x library code provided by ADI, including this file, is provided
	as is without warranty of any kind, either expressed or implied.
 	You assume any and all risk from the use of this code.  It is the
 	responsibility of the person integrating this code into an application
 	to ensure that the resulting application performs as required and is safe.

;Status:		Alpha tested.
;Incomplete:	None.
;Tools:			Developed using IAR V5.1.
;Hardware:		ADuC7060.
;Description:	Example C file using library functions.
;Responsibility:
;    Group:		IAC Software
;    Person:	Eckart Hartmann
;Modifications:
;	2008/02/13	Design Start.
*/
#include	"ioADuC7060.h"
#include	"math.h"
#include	"stdio.h"
#include	"..\LibIar\Adc\LibADC706x.h"
#include	"..\LibIar\Dac\LibDAC706x.h"
#include	"..\LibIar\Urt\LibUrt706x.h"
#include    "..\LibIar\T\LibTim706x.h"
#include    "..\LibIar\Fee\LibFee706x.h"
#include    "..\LibIar\Clk\LibClk706x.h"

//#define	uint	unsigned int

void Delay(unsigned int uLength);
void FeeTest(const int *pi3, const char pc2[]);
void TSet(void);
void CapTest(double d1);

int main(void)
    {
	static const char	pc2[15000] = "Hello";
	static const int i3 = 0x12345678;
    int     b = 1;
    int    	i1;
    int     i2;
    int     iMain;		//Main ADC value.
	int		iAux;		//Aux ADC value.
	int		iGain;		//Gain setting.
	int		iStatus;	//Status of ADCs.
	double	d1;

    while(!(GP2DAT&2))	b = ADC1GN;
	FeeTest(&i3,&pc2[0]);
	i1 = ClkSta(0);
	i1 = ClkPow(1,PUP_ALL,UART_ON);
	UrtCfg(0,URT_96,URT_68|URT_78);
//    UrtCfg(0,355,URT_68|URT_78);
	ADC0OF = 2;
    Delay(100);
	i1 = ADC1GN;
    printf("%s %8x %8x\n\r",pc2,ADC0GN,i1);
	DacCfg(0,DAC_RINT,DAC_ON);
	for(i1=0; i1<256; i1++) for(i2=0; i2<256; i2++) DacOut(0,(i1*256+i2)<<13);
	AdcFlt(127,0,FLT_NOTCH2|FLT_RAVG2|FLT_CHOP);
	AdcGo(3,ADC_CONT,ADC_NORMAL,0);
	TSet();
    while(b)
        {
		TClr(3);
		iGain = AdcAdj(iStatus = AdcRd(&iMain,&iAux));
		DacOut(0,iMain);
		if(UrtSta()&1)
			{
			UrtWr(i2 = UrtRd());
			ADC0CON = 0x8000+(i2&7);
			}
		d1 = 1.2*iMain/0x10000000;
		TMod(0,(d1>0.2),T_BIN);
		CapTest(d1);
		printf("Val0=%08x Cap0=%08x ",TGo(0,0,T_RD),TCap(0,IREAD));
		printf("Val3=%08x ",TGo(3,0,T_RD));
		printf("ADC0 %08x % 11.9f % 8x  \n\r",iMain,d1,iGain);
//        printf("ADC1=%08x % 11.9f % 8x\n\r",iAux,1.2*iAux/0x10000000,iStatus);
		AdcIex((int)(d1*1000),IEX_0ON|IEX_1ON,IEX_0ALT);
		}
    return 0;
    }

